Attribute VB_Name = "ComboWidthMod"
Option Explicit
Private Const CB_SETDROPPEDWIDTH       As Long = &H160
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
                                                                        ByVal wMsg As Long, _
                                                                        ByVal wParam As Long, _
                                                                        lParam As Long) As Long

Public Sub ComboWidthAdjustment(Cmb As ComboBox)

  'Based on VBHelper
  'http://www.vb-helper.com/howto_adjust_combobox_width.html
  'by 'Rocky Mountain Computer Consulting, Inc.'
  'SaveMode added to allow greater safety in case other parts of code expect different ScaleModes
  'cur_wid added to speed up processing
  'Uses Parent so that only the Combo needs to be passed to procedure
  
  Dim I        As Long
  Dim max_wid  As Long
  Dim cur_wid  As Long
  Dim SaveMode As Long

  With Cmb
    'Save Fom's ScaleMode
    SaveMode = .Parent.ScaleMode
    'Reset to vbPixels for TextWidth to work properly
    .Parent.ScaleMode = vbPixels
    'Find longest member
    For I = 0 To .ListCount - 1
      cur_wid = .Parent.TextWidth(.List(I))
      If max_wid < cur_wid Then
        max_wid = cur_wid
      End If
    Next I
    ' Set the width for the dropdown list, adding a margin.
    SendMessage .hwnd, CB_SETDROPPEDWIDTH, max_wid + 10, 0
    'restore form's ScaleMode
    .Parent.ScaleMode = SaveMode
  End With 'Cmb

End Sub
